/*=============================================================================
Turing Designer
de_data.cpp - Designer-specific data structures

  Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2005
  -- License restrictions apply (GPL v2)

  This file is part of Turing Designer.
  Turing Desigenr is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; however ONLY version 2 of the License.

  Turing Designer is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program kit; if not, write to:
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  -- For details see the COPYING file
=============================================================================*/
#include <sys/types.h>
#include <stdlib.h>
#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#    include <wx/wx.h>
#endif
#include "de_data.hpp"

static wxPen
    PEN_SNode(wxColour(0x80, 0x00, 0x00)),
    PEN_INode(wxColour(0x00, 0x00, 0x80)),
    PEN_LNode(wxColour(0x00, 0x40, 0x00));
static wxBrush
    BR_SNode(wxColour(0xFF, 0x80, 0x80)),
    BR_INode(wxColour(0x80, 0xC0, 0xFF)),
    BR_LNode(wxColour(0x80, 0xFF, 0x80));

//-----------------------------------------------------------------------------
void *XVNode::operator new(size_t s) {
    return calloc(1, s);
}

XVNode::XVNode(int x, int y) : VNode() {
    this->x = x;
    this->y = y;
    return;
}

XSNode::XSNode(int x, int y) : SNode(), XVNode(x, y) {
    shape  = DWSHP_CIRCLE;
    radius = 15;
    pen    = &PEN_SNode;
    brush  = &BR_SNode;
    return;
}

XINode::XINode(int x, int y) : INode(), XVNode(x, y) {
    shape  = DWSHP_RECT;
    radius = 20;
    pen    = &PEN_INode;
    brush  = &BR_INode;
    return;
}

XLNode::XLNode(int x, int y) : LNode(), XVNode(x, y) {
    shape  = DWSHP_CIRCLE;
    radius = 5;
    pen    = &PEN_LNode;
    brush  = &BR_LNode;
    return;
}

//==[ End of file ]============================================================
