/*=============================================================================
Turing Designer
de_data.cpp - Designer-specific data structures

  Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2005
  -- License restrictions apply (GPL v2)

  This file is part of Turing Designer.
  Turing Desigenr is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; however ONLY version 2 of the License.

  Turing Designer is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program kit; if not, write to:
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  -- For details see the COPYING file
=============================================================================*/
#ifndef DE_DATA_HPP
#define DE_DATA_HPP 1

#include <sys/types.h>
#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#    include <wx/wx.h>
#endif
#include "gr_data.hpp"

enum {
    DWSHP_INVALID = 0,
    DWSHP_CIRCLE,
    DWSHP_RECT,
    DWSHP_MAX,
};

class XVNode : public virtual VNode {
  public: // functions
    static void *operator new(size_t);
    XVNode(int = -1, int = -1);

  public: // variables
    unsigned int shape;
    int x, y, radius;
    bool sel;
    wxBrush *brush, *o_brush;
    wxPen *pen, *o_pen;
};

class XSNode : public virtual SNode, public virtual XVNode {
  public: // functions
    XSNode(int = 0, int = 0);
    inline const unsigned int type(void) const { return TYPE_SNODE; };
};

class XINode : public virtual INode, public virtual XVNode {
  public: // functions
    XINode(int = 0, int = 0);
    inline const unsigned int type(void) const { return TYPE_INODE; };
};

class XLNode : public virtual LNode, public virtual XVNode {
  public: // functions
    XLNode(int = 0, int = 0);
    inline const unsigned int type(void) const { return TYPE_LNODE; };
};

#endif // DE_DATA_HPP

//==[ End of file ]============================================================
