/*=============================================================================
Turing Designer
de_genw.hpp - Generic GUI windows

  Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2005
  -- License restrictions apply (GPL v2)

  This file is part of Turing Designer.
  Turing Desigenr is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; however ONLY version 2 of the License.

  Turing Designer is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program kit; if not, write to:
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  -- For details see the COPYING file
=============================================================================*/
#ifndef DE_GENW_HPP
#define DE_GENW_HPP 1

#include <stdio.h>
#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#    include <wx/wx.h>
#endif
#include <wx/minifram.h>

class GTButton : public wxButton {
  public: // functions
    GTButton(wxWindow *, wxWindowID, const char *, const wxColour * = NULL,
     const char * = NULL, long = 0);
};

class GWButton : public wxBitmapButton {
  public: // functions
    GWButton(wxWindow *, wxWindowID, const wxBitmap &, const char * = NULL);
};

/* GWMenu
   Adds the WIcon method
*/
class GWMenu : public wxMenu {
  public:
    GWMenu(const wxString & = wxEmptyString, long = 0);
    void Append_WIcon(int, const wxString &, const wxBitmap &,
     const char * = NULL, wxItemKind = wxITEM_NORMAL);
};

/* GWMesssage
   Yes/No/Cancel prompt
*/
class GWMessage : public wxDialog {
  public:
    GWMessage(wxWindow *, const char * = NULL, const char * = NULL, long = 0,
     long = 0, wxWindowID = -1, const wxPoint & = wxDefaultPosition,
     const wxSize & = wxDefaultSize);

  protected:
    void Yes(wxCommandEvent &);
    void No(wxCommandEvent &);

  private:
    DECLARE_EVENT_TABLE();
};

/* GWText
   A text prompter, OK/Cancel
*/
class GWText : public wxDialog {
  public:
    GWText(wxWindow *, const char * = NULL, const char * = NULL,
     const char * = NULL, bool = false, wxWindowID = -1,
     const wxPoint & = wxDefaultPosition, const wxSize & = wxDefaultSize);
    const char *get_value(void);

  protected:
    wxTextCtrl *field;
};

#endif // DE_GENW_HPP

//==[ End of file ]============================================================
