/*=============================================================================
Turing Designer
si_tape.hpp - GUI Tape

  Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2005
  -- License restrictions apply (GPL v2)

  This file is part of Turing Designer.
  Turing Desigenr is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; however ONLY version 2 of the License.

  Turing Designer is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program kit; if not, write to:
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  -- For details see the COPYING file
=============================================================================*/
#ifndef SI_TAPE_HPP
#define SI_TAPE_HPP 1

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#    include <wx/wx.h>
#endif
#include "si_sim.hpp"
#include "tu_tape.hpp"

class SimTape : public wxPanel, public TuTape {
  public: // functions
    SimTape(Simulator *);
    ~SimTape(void);
    char &operator *(void) const;
    char &operator [](size_t i);
    int operator --(void);
    int operator ++(void);
    void update(void);

  private: // functions
    void Initialize(wxCommandEvent &);
    void Movl(wxCommandEvent &);
    void Movr(wxCommandEvent &);
    void extend(size_t);

  private: // variables
    Simulator *super;
    wxTextCtrl *tx_init;
    wxStaticText *tx_data, *tx_head;
    wxString *str_data, *str_head;
    int head_pos;

    DECLARE_EVENT_TABLE();
};

#endif // SI_TAPE_HPP

//==[ End of file ]============================================================
