/*=============================================================================
Turing Designer
tu_mach.hpp - UI-neutral Turing Machine

  Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2005
  -- License restrictions apply (GPL v2)

  This file is part of Turing Designer.
  Turing Desigenr is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; however ONLY version 2 of the License.

  Turing Designer is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program kit; if not, write to:
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  -- For details see the COPYING file
=============================================================================*/
#ifndef TU_MACH_HPP
#define TU_MACH_HPP 1

#include <sys/types.h>

class VNode;
class TGraph;
class TuTape;

class TuMach {
  public: // functions
    TuMach(TGraph *, TuTape *);
    bool preview(int *, char *, char *, char *, int *);
    int run(void);
    int tick(void);
    void reset(void);

  protected: // variables
    TGraph *graph;
    TuTape *tape;
    int current;
};

#endif // TU_MACH_HPP

//==[ End of file ]============================================================
