/*=============================================================================
Turing Designer
tu_tape.hpp - UI-neutral Tape implementation

  Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2005
  -- License restrictions apply (GPL v2)

  This file is part of Turing Designer.
  Turing Desigenr is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; however ONLY version 2 of the License.

  Turing Designer is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program kit; if not, write to:
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  -- For details see the COPYING file
=============================================================================*/
#ifndef TU_TAPE_HPP
#define TU_TAPE_HPP 1

#include <sys/types.h>
#include <stdio.h>

class TuTape {
  public: // functions
    TuTape(const char * = NULL, int = -1);
    virtual ~TuTape(void);
    virtual char &operator *(void) const { return data[head_pos]; }
    virtual char &operator [](size_t i) const { return data[i]; }
    virtual int operator --(void);
    virtual int operator ++(void);
    virtual void update(void);

  private: // functions
    void extend(size_t);

  private: // variables
    char *data;
    size_t dlen;
    unsigned int head_pos;
};

#endif // TU_TAPE_HPP

//==[ End of file ]============================================================
