/*=============================================================================
Turing Designer
xf_ldr.cpp - MainWindow loader

  Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2005
  -- License restrictions apply (GPL v2)

  This file is part of Turing Designer.
  Turing Desigenr is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; however ONLY version 2 of the License.

  Turing Designer is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program kit; if not, write to:
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  -- For details see the COPYING file
=============================================================================*/
#include <stdio.h>
#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#    include <wx/wx.h>
#endif
#include "xf_icons.hpp"
#include "xf_main.hpp"

//-----------------------------------------------------------------------------
class MyApp : public wxApp {
  public:
    bool OnInit(void);
};

IMPLEMENT_APP(MyApp);

bool MyApp::OnInit(void) {
    wxInitAllImageHandlers();
    initialize_icons();
    SetTopWindow(new_mw());
    return true;
}

MainWindow *new_mw(TGraph *t) {
    MainWindow *mw = new MainWindow("Turing Designer",
      wxDefaultPosition, wxSize(800, 600), t);
    mw->Show(true);
    return mw;
}

//==[ End of file ]============================================================
